{
procedure flip_horizontal(Quelle, Ziel: TBitMap);
begin
  Ziel.Assign(nil);
  Ziel.Width  := Quelle.Width;
  Ziel.Height := Quelle.Height;
  StretchBlt(Ziel.Canvas.Handle, 0, 0, Ziel.Width, Ziel.Height, Quelle.Canvas.Handle,
    0, Quelle.Height, Quelle.Width, Quelle.Height, srccopy);
end;

procedure flip_vertikal(Quelle, Ziel: TBitMap);
begin
  Ziel.Assign(nil);
  Ziel.Width  := Quelle.Width;
  Ziel.Height := Quelle.Height;
  StretchBlt(Ziel.Canvas.Handle, 0, 0, Ziel.Width, Ziel.Height, Quelle.Canvas.Handle,
    Quelle.Width, 0, Quelle.Width, Quelle.Height, srccopy);
end;
}

unit unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, LResources, Forms, Controls, Graphics, Dialogs,
  LCLType, LCLIntf, LCLProc,uplprinceofpersia,
  Buttons, ExtCtrls, StdCtrls, uplspriteengine;

type

  { TForm1 }

  TForm1 = class(TForm)
    ListBox1: TListBox;
    PaintBox1: TPaintBox;
    Panel1: TPanel;
    Timer1: TTimer;
    procedure BitBtn1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
    procedure FormPaint(Sender: TObject);
    procedure ListBox1DrawItem(Control: TWinControl; Index: Integer;
      ARect: TRect; State: TOwnerDrawState);
    procedure ListBox1SelectionChange(Sender: TObject; User: boolean);
    procedure PaintBox1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PaintBox1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure PaintBox1Paint(Sender: TObject);
    procedure PaintBox1Resize(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    { private declarations }
  public
    PrinceOfPersia:TPlPrinceOfPersia;
    spriteengine:TPLSpriteEngine;
    sp:TPLGameSprite;
    player:TPLKid;
    { public declarations }
  end; 

var
  Form1: TForm1; 

implementation

{ TForm1 }

procedure TForm1.BitBtn1Click(Sender: TObject);
begin
 { Canvas.FillRect(0,0,Form1.Width, Form1.Height);
  NormalPanel.Paint(Canvas,10,200);

  NormalPanel.Paint(Canvas,10+32,200);
  NormalPanel.Paint(Canvas,10+(32*2),200);

  SpikesPanel.Paint(Canvas,10+(32*3),200);

  skeleton.Paint(Canvas,10+(32*4),200);

  NormalPanel.Paint(Canvas,10+(32*5),200);

  Bigpillar.Paint(Canvas,10+(32*6),200);

  Door.Paint(Canvas,10+(32*7),200);

  Kid.Paint(Canvas,10+(32*2),200);

  NormalPanel.Paint(Canvas,10+(32*6),140);
  NormalPanel.Paint(Canvas,10+(32*7),140);}
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  DataDir2:String;
  x,px,y,py, pw,ph,i:Integer;
begin
//  DataDir:=ExtractFileDir(ParamStr(0)) + DirectorySeparator + 'data' + DirectorySeparator;
  DataDir2:=ExtractFileDir(ParamStr(0)) + DirectorySeparator + 'testdata' + DirectorySeparator;
  sp:=nil;
  PrinceOfPersia:=TPlPrinceOfPersia.Create(640,480,120 div 2,155 div 2);
  PrinceOfPersia.Canvas:=PaintBox1.Canvas;
  for i:=0 to PrinceOfPersia.ClassList.Count-1 do begin
    with PrinceOfPersia.ClassList[i] as TClassItem do begin
      ListBox1.Items.AddObject(Name, C);
    end;
  end; // for i

//  pw:=Form1.Width div 32;
//  ph:=Form1.Height div 32;
//  PrinceOfPersia.SpriteEngine.Canvas:=Form1.Canvas;
//  PrinceOfPersia.SpriteEngine.Left:=0;
//  PrinceOfPersia.SpriteEngine.Top:=0;
//  PrinceOfPersia.SpriteEngine.SetGameSize;
  // 10,7
//  writeln(PrinceOfPersia.SpriteEngine.TileHoriCount,'||',PrinceOfPersia.SpriteEngine.TileVertiCount);
{  PrinceOfPersia.AddGameSprite(32*1,(ph-2)*32, TPLNormalPanel.Create(nil,PrinceOfPersia.SpriteEngine, PrinceOfPersia));
  PrinceOfPersia.AddGameSprite(32*2,(ph-2)*32, TPLNormalPanel.Create(nil,PrinceOfPersia.SpriteEngine, PrinceOfPersia));
  PrinceOfPersia.AddGameSprite(32*3,(ph-2)*32, TPLNormalPanel.Create(nil,PrinceOfPersia.SpriteEngine, PrinceOfPersia));
  PrinceOfPersia.AddGameSprite(32*4,(ph-2)*32, TPLNormalPanel.Create(nil,PrinceOfPersia.SpriteEngine, PrinceOfPersia));
  PrinceOfPersia.AddGameSprite(32*5,(ph-2)*32, TPLNormalPanel.Create(nil,PrinceOfPersia.SpriteEngine, PrinceOfPersia));

  PrinceOfPersia.AddGameSprite(32*1,(ph-4)*32, TPLNormalPanel.Create(nil,PrinceOfPersia.SpriteEngine, PrinceOfPersia));
  PrinceOfPersia.AddGameSprite(32*2,(ph-4)*32, TPLNormalPanel.Create(nil,PrinceOfPersia.SpriteEngine, PrinceOfPersia));
  PrinceOfPersia.AddGameSprite(32*3,(ph-4)*32, TPLNormalPanel.Create(nil,PrinceOfPersia.SpriteEngine, PrinceOfPersia));
  PrinceOfPersia.AddGameSprite(32*4,(ph-4)*32, TPLNormalPanel.Create(nil,PrinceOfPersia.SpriteEngine, PrinceOfPersia));
  PrinceOfPersia.AddGameSprite(32*5,(ph-4)*32, TPLNormalPanel.Create(nil,PrinceOfPersia.SpriteEngine, PrinceOfPersia));


  PrinceOfPersia.AddGameSprite(32*7,(ph-2)*32, TPLNormalPanel.Create(nil,PrinceOfPersia.SpriteEngine, PrinceOfPersia));
  PrinceOfPersia.AddGameSprite(32*8,(ph-2)*32, TPLNormalPanel.Create(nil,PrinceOfPersia.SpriteEngine, PrinceOfPersia));
  PrinceOfPersia.AddGameSprite(32*9,(ph-2)*32, TPLNormalPanel.Create(nil,PrinceOfPersia.SpriteEngine, PrinceOfPersia));
  PrinceOfPersia.AddGameSprite(32*10,(ph-2)*32, TPLNormalPanel.Create(nil,PrinceOfPersia.SpriteEngine, PrinceOfPersia));
  PrinceOfPersia.AddGameSprite(32*11,(ph-2)*32, TPLNormalPanel.Create(nil,PrinceOfPersia.SpriteEngine, PrinceOfPersia));

  PrinceOfPersia.AddGameSprite(32*12,(ph-2)*32-6,TPLSkeleton.Create(nil,PrinceOfPersia.SpriteEngine, PrinceOfPersia));

  PrinceOfPersia.AddGameSprite(32*7,(ph-4)*32, TPLNormalPanel.Create(nil,PrinceOfPersia.SpriteEngine, PrinceOfPersia));
  PrinceOfPersia.AddGameSprite(32*8,(ph-4)*32, TPLNormalPanel.Create(nil,PrinceOfPersia.SpriteEngine, PrinceOfPersia));
  PrinceOfPersia.AddGameSprite(32*9,(ph-4)*32, TPLNormalPanel.Create(nil,PrinceOfPersia.SpriteEngine, PrinceOfPersia));
  PrinceOfPersia.AddGameSprite(32*10,(ph-4)*32, TPLNormalPanel.Create(nil,PrinceOfPersia.SpriteEngine, PrinceOfPersia));
  PrinceOfPersia.AddGameSprite(32*11,(ph-4)*32, TPLNormalPanel.Create(nil,PrinceOfPersia.SpriteEngine, PrinceOfPersia));


  PrinceOfPersia.AddGameSprite(32*13,(ph-4)*32-47, TPlBigPillar.Create(nil,PrinceOfPersia.SpriteEngine, PrinceOfPersia));


  PrinceOfPersia.AddGameSprite(32*13,((ph-3)*32)-28, TPLDoor.Create(nil,PrinceOfPersia.SpriteEngine, PrinceOfPersia));
  PrinceOfPersia.AddGameSprite(32*14,(ph-2)*32,TPLSpikes.Create(nil,PrinceOfPersia.SpriteEngine, PrinceOfPersia));

  PrinceOfPersia.AddGameSprite(32*15,(ph-2)*32-54,TPLPillar.Create(nil,PrinceOfPersia.SpriteEngine, PrinceOfPersia));

  PrinceOfPersia.AddGameSprite(32*14,(ph-4)*32, TPLNormalPanel.Create(nil,PrinceOfPersia.SpriteEngine, PrinceOfPersia));
  PrinceOfPersia.AddGameSprite(32*15,(ph-4)*32, TPLNormalPanel.Create(nil,PrinceOfPersia.SpriteEngine, PrinceOfPersia));

  PrinceOfPersia.AddGameSprite(32*10,(ph-8)*32, TPLNormalPanel.Create(nil,PrinceOfPersia.SpriteEngine, PrinceOfPersia));
  PrinceOfPersia.AddGameSprite(32*11,(ph-8)*32-53, TPLLevelDoor.Create(nil,PrinceOfPersia.SpriteEngine, PrinceOfPersia));
  PrinceOfPersia.AddGameSprite(32*12,(ph-8)*32, TPLNormalPanel.Create(nil,PrinceOfPersia.SpriteEngine, PrinceOfPersia));
  PrinceOfPersia.AddGameSprite(32*13,(ph-8)*32, TPLBroken.Create(nil,PrinceOfPersia.SpriteEngine, PrinceOfPersia));
  PrinceOfPersia.AddGameSprite(32*14,(ph-8)*32, TPLLoose.Create(nil,PrinceOfPersia.SpriteEngine, PrinceOfPersia));

  player:=PrinceOfPersia.AddGameSprite(32*11,(ph-3)*32, TPLKid.Create(nil,PrinceOfPersia.SpriteEngine, PrinceOfPersia)) as TPLKid;}


  exit;
{  spriteengine:=TPLSpriteEngine.Create(Form1.Width, Form1.Height);
  spriteengine.ImageList.AddImageItem(DataDir2+'obj1.png');
  spriteengine.ImageList.AddImageItem(DataDir2+'obj2.png');
  spriteengine.ImageList.AddImageItem(DataDir2+'obj3.png');
  spriteengine.ImageList.AddImageItem(DataDir2+'player1.png');}

  px:=1; py:=ph-2;
{  player:=spriteengine.AddSprite(px*32,py*32,spriteengine.ImageList.Item[3]);

  px:=0; py:=0;
  for x:=0 to pw do begin
    spriteengine.AddSprite(px*32,py*32,spriteengine.ImageList.Item[0]);
    inc(px);
  end; // for

  px:=0; py:=ph-1;
  for x:=0 to pw do begin
    spriteengine.AddSprite(px*32,py*32,spriteengine.ImageList.Item[0]);
    inc(px);
  end; // for

  py:=1; px:=0;
  for y:=0 to ph-3 do begin
    spriteengine.AddSprite(px*32,py*32,spriteengine.ImageList.Item[1]);
    inc(py);
  end; // for

  py:=1; px:=pw-1;
  for y:=0 to ph-3 do begin
    spriteengine.AddSprite(px*32,py*32,spriteengine.ImageList.Item[1]);
    inc(py);
  end; // for

  py:=4; px:=2;
  for y:=0 to 3 do begin
    spriteengine.AddSprite(px*32,py*32,spriteengine.ImageList.Item[2]);
    inc(px);
  end; // for

  py:=8; px:=2;
  for y:=0 to 3 do begin
    spriteengine.AddSprite(px*32,py*32,spriteengine.ImageList.Item[2]);
    inc(px);
  end; // for

  py:=12; px:=2;
  for y:=0 to 3 do begin
    spriteengine.AddSprite(px*32,py*32,spriteengine.ImageList.Item[2]);
    inc(px);
  end; // for

  py:=4; px:=8;
  for y:=0 to 3 do begin
    spriteengine.AddSprite(px*32,py*32,spriteengine.ImageList.Item[2]);
    inc(px);
  end; // for

  py:=8; px:=8;
  for y:=0 to 3 do begin
    spriteengine.AddSprite(px*32,py*32,spriteengine.ImageList.Item[2]);
    inc(px);
  end; // for

  py:=12; px:=8;
  for y:=0 to 3 do begin
    spriteengine.AddSprite(px*32,py*32,spriteengine.ImageList.Item[2]);
    inc(px);
  end; // for

  py:=4; px:=14;
  for y:=0 to 3 do begin
    spriteengine.AddSprite(px*32,py*32,spriteengine.ImageList.Item[2]);
    inc(px);
  end; // for

  py:=8; px:=14;
  for y:=0 to 3 do begin
    spriteengine.AddSprite(px*32,py*32,spriteengine.ImageList.Item[2]);
    inc(px);
  end; // for

  py:=12; px:=14;
  for y:=0 to 3 do begin
    spriteengine.AddSprite(px*32,py*32,spriteengine.ImageList.Item[2]);
    inc(px);
  end; // for}

//  spriteengine.AddSprite(60,60,spriteengine.ImageList.Item[1]);
{  Open:=True;
  NormalPanel:=TPLNormalPanel.Create;
  SpikesPanel:=TPLSpikes.Create;
  skeleton:=TPLSkeleton.Create;
  Bigpillar:=TPLBigpillar.Create;
  Kid:=TPLKid.Create;
  Door:=TPLDoor.Create;}
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  FreeAndNil(spriteengine);
{  FreeAndNil(NormalPanel); FreeAndNil(SpikesPanel); FreeAndNil(skeleton);
  FreeAndNil(Bigpillar); FreeAndNil(Kid); FreeAndNil(Door);}
end;

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState
  );
begin
  exit;
  PrinceOfPersia.keys[key]:=True;
  player.Timer.Enabled:=True;
{  case key of
    VK_LEFT: begin
{      Player.isBackupBuffer:=False;
      if not Player.dir then begin
        Player.dir:=True;
      end;

     if not player.Timer.Enabled then
        player.Timer.Enabled:=True;}
    end; // VK_Left

    VK_RIGHT: begin
{        Player.isBackupBuffer:=False;

      if Player.dir then begin
        Player.dir:=False;
      end;
      if not player.Timer.Enabled then
        player.Timer.Enabled:=True;}
    end; // VK_RIGHT

    VK_DOWN: begin
//      player.Top:=player.Top+32;
    end; // VK_DOWN

    VK_UP: begin
      player.Top:=player.Top-32;
    end; // VK_UP
  end; // case}
end;

procedure TForm1.FormKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  PrinceOfPersia.keys[key]:=False;
//  player.Timer.Enabled:=False;
end;

procedure TForm1.FormMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  Caption:=IntTostr(x) + ':' + IntToStr(y);
end;

procedure TForm1.FormPaint(Sender: TObject);
begin

end;

procedure TForm1.ListBox1DrawItem(Control: TWinControl; Index: Integer; ARect: TRect; State: TOwnerDrawState);
var
  cl:TPLGameSprite;
begin
  with Control as TListBox do begin
    if odSelected in State then begin
      Canvas.Brush.Color:=clBlue;
      Canvas.Font.Color:=clred;
    end
    else begin
      Canvas.Brush.Color:=clBlack;
      Canvas.Font.Color:=clYellow;
    end;

    Canvas.FillRect(ARect);
    cl:=Items.Objects[index] as TPLGameSprite;

    Canvas.Draw(0,ARect.Top,cl.BitMap);
    Canvas.TextOut(0,ARect.Top+cl.BitMap.Height,Items[index]+' '+IntToStr(cl.BitMap.Width) + ':'+IntTostr(cl.BitMap.Height) + '');
  end; // with
end;

procedure TForm1.ListBox1SelectionChange(Sender: TObject; User: boolean);
begin
  if Assigned(sp) then begin
    sp.Restor;
    FreeAndNil(sp);
  end;

  sp:=TPLGameSprite(ListBox1.Items.Objects[ListBox1.ItemIndex]).Create2;
  sp.Paint(True);
end;

procedure TForm1.PaintBox1MouseDown(Sender: TObject; Button: TMouseButton;Shift: TShiftState; X, Y: Integer);
var
  tx,ty,i,px,py,pw,ph:Integer;
  c:TPLGameSprite;
begin
  tx:=x div PrinceOfPersia.TileWidth;
  ty:=y div PrinceOfPersia.TileHeight;

  if button = mbRight then begin
    if Assigned(PrinceofPersia.Map[ty,tx]) then begin
      if Assigned(sp) then sp.isBackupBuffer:=False;
      px:=0;
      pw:=PaintBox1.Width;
      ph:=PrinceOfPersia.TileHeight;
      py:=PrinceOfPersia.map[ty,tx].Top-PrinceOfPersia.Map[ty,tx].BitMap.Height;

      FreeAndNil(PrinceOfPersia.map[ty,tx]);
      BitBlt(PrinceOfPersia.BackupBuffer.Canvas.Handle,px,py,pw,ph,PrinceOfPersia.Background.Canvas.Handle,px,py,SRCCOPY);
      BitBlt(PrinceOfPersia.Canvas.Handle,px,py,pw,ph,PrinceOfPersia.Background.Canvas.Handle,px,py,SRCCOPY);

      for i:=0 to PrinceOfPersia.TileHoriCount do begin
        if Assigned(PrinceOfPersia.map[ty,i]) then begin
          PrinceOfPersia.map[ty,i].isBackupBuffer:=False;
          PrinceOfPersia.map[ty,i].Paint(True);
        end;
      end;
    end;
  end;

  if button = mbLeft then begin
    if ((not (sp is TPLBackground)) and ((not (sp is TPLItems)))) and (Assigned(PrinceofPersia.Map[ty,tx])) then begin
      PrinceOfPersia.map[ty,tx].Restor;
      FreeAndNil(PrinceOfPersia.map[ty,tx]);
    end;

    if not Assigned(PrinceofPersia.Map[ty,tx]) then begin
      if (sp is TPLBackground) or (sp is TPLItems)then exit;
      c:=ListBox1.Items.Objects[ListBox1.ItemIndex] as TPLGameSprite;
      if Assigned(sp) then sp.isBackupBuffer:=False;

      PrinceOfPersia.AddGameSprite(tx,ty, c.Create2);

      px:=0;
      pw:=PaintBox1.Width;
      ph:=PrinceOfPersia.TileHeight-PrinceOfPersia.Map[ty,tx].BitMap.Height;
      py:=PrinceOfPersia.Map[ty,tx].Top-ph;

      BitBlt(PrinceOfPersia.BackupBuffer.Canvas.Handle,px,py,pw,ph,PrinceOfPersia.Background.Canvas.Handle,px,py,SRCCOPY);
      BitBlt(PrinceOfPersia.Canvas.Handle,px,py,pw,ph,PrinceOfPersia.Background.Canvas.Handle,px,py,SRCCOPY);


      for i:=0 to PrinceOfPersia.TileHoriCount do begin
        if Assigned(PrinceOfPersia.map[ty,i]) then begin
          PrinceOfPersia.map[ty,i].isBackupBuffer:=False;
          PrinceOfPersia.map[ty,i].Paint(True);
        end;
      end;
    end
    else begin
      if not Assigned((PrinceOfPersia.Map[ty,tx] as TPLGameSprite).Data) then begin
        if sp is TPLBackground then begin
          (PrinceOfPersia.Map[ty,tx] as TPLGameSprite).Data:=sp.Create2;
          (PrinceOfPersia.Map[ty,tx] as TPLGameSprite).Data.Left:=(tx*PrinceOfPersia.TileWidth)+5;
          (PrinceOfPersia.Map[ty,tx] as TPLGameSprite).Data.Top:=(ty*PrinceOfPersia.TileHeight)-50;
          (PrinceOfPersia.Map[ty,tx] as TPLGameSprite).Data.Paint(True);
        end
        else begin
          if sp is TPLItems then begin
            px:=tx * PrinceOfPersia.TileWidth;
            (PrinceOfPersia.Map[ty,tx] as TPLGameSprite).Data:=sp.Create2;
            (PrinceOfPersia.Map[ty,tx] as TPLGameSprite).Data.Left:=px+(PrinceOfPersia.TileWidth div 2);
            (PrinceOfPersia.Map[ty,tx] as TPLGameSprite).Data.Top:=(ty * PrinceOfPersia.TileHeight);
            (PrinceOfPersia.Map[ty,tx] as TPLGameSprite).Data.Paint(True);
          end;
        end;
      end;
    end;

  end;
end;

procedure TForm1.PaintBox1MouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
var
  tx,ty,px,py:Integer;
  pt:Tpoint;
begin
  tx:=x div PrinceOfPersia.TileWidth;
  ty:=y div PrinceOfPersia.TileHeight;

  if Assigned(sp) then begin
    px:=tx*PrinceOfPersia.TileWidth;
//    Caption:=IntTostr(px)+':'+IntToStr(tx);
    py:=ty * PrinceOfPersia.TileHeight;

    if (px <> sp.Left) or (sp.Top <> py) then begin
      sp.Restor;
      sp.Left:=px;
      sp.Top:=py;
      sp.Paint(True);
    end;
  end;
end; // TForm1.PaintBox1MouseMove

procedure TForm1.PaintBox1Paint(Sender: TObject);
begin
  PrinceOfPersia.Paint;
end;

procedure TForm1.PaintBox1Resize(Sender: TObject);
begin

end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
 { if Open then begin
    if Door.Status+1 > 5 then
      Open:=False
    else begin
      Door.Status:=Door.Status+1;
    end;
    Door.Paint(Canvas,10+(32*7),200);
  end
  else begin
    if Door.Status-1 < 0 then
      Open:=True
    else begin
      Door.Status:=Door.Status-1;
//      Door.Paint(Canvas,10+(32*7),200);
    end;
//    Door.Paint(Canvas,10+(32*7),200);
    BitBtn1Click(Sender);
  end;  }
end;

initialization
  {$I unit1.lrs}

end.

